#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_with	verbose		# verbose build (V=1)
%bcond_with	dkms	# build dkms package

%if "%{_alt_kernel}" != "%{nil}"
%if 0%{?build_kernels:1}
%{error:alt_kernel and build_kernels are mutually exclusive}
exit 1
%endif
%global		_build_kernels		%{alt_kernel}
%else
%global		_build_kernels		%{?build_kernels:,%{?build_kernels}}
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		_duplicate_files_terminate_build	0

%define		kbrs	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo "BuildRequires:kernel%%{_alt_kernel}-module-build >= 3:2.6.20.2" ; done)
%define		kpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%kernel_pkg ; done)
%define		bkpkg	%(echo %{_build_kernels} | tr , '\\n' | while read n ; do echo %%undefine alt_kernel ; [ -z "$n" ] || echo %%define alt_kernel $n ; echo %%build_kernel_pkg ; done)

%define		rel	29
%define		pname	nvidiabl
Summary:	Linux driver for nVidia display back-lights
Name:		%{pname}%{_alt_kernel}
Version:	0.81
Release:	%{rel}%{?_pld_builder:@%{_kernel_ver_str}}
License:	GPL v2+
URL:		https://github.com/guillaumezin/nvidiabl
Source0:	https://github.com/guillaumezin/nvidiabl/archive/v%{version}.tar.gz?/%{pname}-%{version}.tgz
# Source0-md5:	f72d90c0fe34b36a0ff3b6d7034e99c4
Source1:	modprobe.conf
Patch0:		nvidiabl-dkmsconf.patch
Group:		Base/Kernel
BuildRequires:	rpmbuild(macros) >= 1.678
%{?with_dist_kernel:%{expand:%kbrs}}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This driver drives the smartdimmer register found on modern mobile
nVidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to
adjust the display backlight.

On Apple machines this driver allows more fine-grained brightness
adjustment than the (mbp_nvidia_bl) driver and is generally preferred.

%package -n dkms-%{pname}
Summary:	DKMS-ready driver for nVidia display back-lights
License:	GPL v2+
Group:		Base/Kernel
Requires(pre):	dkms
Requires(post):	dkms
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n dkms-%{pname}
This package contains a DKMS-ready driver for nvidia laptop display
back-lights.

This driver drives the smartdimmer register found on modern mobile
Nvidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to
adjust the display backlight.

On Apple machines this driver allows more fine-grained brightness
adjustment than the mbp-nvidia-bl-dkms (mbp_nvidia_bl) driver and is
generally preferred.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-video-nvidiabl\
Summary:	Linux driver for nVidia display back-lights\
Summary(pl.UTF-8):	Sterownik dla Linuksa do nvidiabl\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%if %{with dist_kernel}\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
%endif\
\
%description -n kernel%{_alt_kernel}-video-nvidiabl\
This driver drives the smartdimmer register found on modern mobile\
nVidia graphics adapters such as NV40, NV41, NV43, NV44, NV46, NV47,\
NV49, NV4B, C51, G84, G86, G92, G94, G96, GT200 architectures to\
adjust the display backlight.\
\
On Apple machines this driver allows more fine-grained brightness\
adjustment than the (mbp_nvidia_bl) driver and is generally preferred.\
\
%description -n kernel%{_alt_kernel}-video-nvidiabl -l pl.UTF-8\
Sterownik dla Linuksa do nvidiabl.\
\
Ten pakiet zawiera moduł jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-video-nvidiabl\
%defattr(644,root,root,755)\
/lib/modules/%{_kernel_ver}/misc/*.ko*\
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/%{pname}.conf\
\
%post	-n kernel%{_alt_kernel}-video-nvidiabl\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-video-nvidiabl\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%build_kernel_modules -m nvidiabl\
%install_kernel_modules -D installed -m nvidiabl -d misc\
%{nil}

%{expand:%kpkg}

%prep
%setup -qn %{pname}-%{version}
%patch0 -p1

%build
%{expand:%bkpkg}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/modprobe.d

cp -p %{SOURCE1} $RPM_BUILD_ROOT/etc/modprobe.d/%{pname}.conf
cp -a installed/* $RPM_BUILD_ROOT

%if %{with dkms}
install -d $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
cp -p Makefile *.[ch] $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
sed -e 's|@pname@|%{pname}|g' -e 's|@MODVERSION@|%{version}-%{rel}|g' \
	dkms.conf > $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}/dkms.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n dkms-%{pname}
%{_sbindir}/dkms add -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms build -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms install -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade || :

%preun -n dkms-%{pname}
%{_sbindir}/dkms remove -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade --all || :

%if %{with dkms}
%files -n dkms-%{pname}
%defattr(644,root,root,755)
%{_usrsrc}/%{pname}-%{version}-%{rel}
%endif
%changelog
* Thu Jan 02 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nvidiabl.git;a=log;h=auto/th/nvidiabl-0.81-29

* Mon Oct 28 2013 Jan Rękorajski <baggins@pld-linux.org> 0406611
- switch to macro driven module build for multiple kernel versions
- rel 29

* Mon Oct 07 2013 Jan Rękorajski <baggins@pld-linux.org> 83a43a7
- rebuild for kernel-3.10.15-1
- release 28 (by relup.sh)

* Wed Oct 02 2013 Jan Rękorajski <baggins@pld-linux.org> a89e24c
- rebuild for kernel-3.10.14-1
- release 27 (by relup.sh)

* Fri Sep 27 2013 Jan Rękorajski <baggins@pld-linux.org> e9d3750
- rebuild for kernel-3.10.13-1
- release 26 (by relup.sh)

* Sun Sep 15 2013 Jan Rękorajski <baggins@pld-linux.org> c08a8f8
- rebuild for kernel-3.10.12-1
- release 25 (by relup.sh)

* Tue Sep 10 2013 Jan Rękorajski <baggins@pld-linux.org> 4b3928a
- rebuild for kernel-3.10.11-1
- release 24 (by relup.sh)

* Thu Aug 29 2013 Jan Rękorajski <baggins@pld-linux.org> 26781f8
- rebuild for kernel-3.10.10-1
- release 23 (by relup.sh)

* Sat Aug 24 2013 Jan Rękorajski <baggins@pld-linux.org> 4d25580
- rebuild for kernel-3.10.9-1
- release 22 (by relup.sh)

* Thu Aug 15 2013 Jan Rękorajski <baggins@pld-linux.org> ed8db40
- release 21 (by relup.sh)

* Thu Jul 25 2013 Jan Rękorajski <baggins@pld-linux.org> f405412
- rebuild for kernel-3.9.11-1
- release 20 (by relup.sh)

* Wed Jul 03 2013 Jan Rękorajski <baggins@pld-linux.org> 1ea715f
- rebuild for kernel-3.9.9-1
- release 19 (by relup.sh)

* Thu Jun 27 2013 Jan Rękorajski <baggins@pld-linux.org> fc55975
- rebuild for kernel-3.9.8-1
- release 18 (by relup.sh)

* Thu Jun 20 2013 Jan Rękorajski <baggins@pld-linux.org> c696788
- rebuild for kernel-3.9.7-1
- release 17 (by relup.sh)

* Thu Jun 13 2013 Jan Rękorajski <baggins@pld-linux.org> f7110ec
- rebuild for kernel-3.9.6-1
- release 16 (by relup.sh)

* Fri Jun 07 2013 Jan Rękorajski <baggins@pld-linux.org> 5a1d77a
- rebuild for kernel-3.9.5-1 /home/users/baggins/devel/PLD/rpm/packages
- release 15 (by relup.sh)

* Mon Jun 03 2013 Jan Rękorajski <baggins@pld-linux.org> 0b73a15
- rebuild for kernel-3.9.4-3
- release 14 (by relup.sh)

* Fri May 24 2013 Jan Rękorajski <baggins@pld-linux.org> 29c334a
- rebuild for kernel-3.7.10-9
- release 13 (by relup.sh)

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 1f046d4
- rebuild for kernel-3.7.10-8
- release 12 (by relup.sh)

* Thu May 02 2013 Jan Rękorajski <baggins@pld-linux.org> 41a38f3
- release 11 (by relup.sh)

* Thu Apr 18 2013 Jan Rękorajski <baggins@pld-linux.org> 6d37035
- rebuild for kernel-3.7.10-7
- release 10 (by relup.sh)

